from Globals import InitializeClass, DTMLFile
from AccessControl import ClassSecurityInfo
from OFS.SimpleItem import SimpleItem
from OFS.PropertyManager import PropertyManager
from Acquisition import Implicit, aq_base
from cgi import escape

from Products.CMFCore.utils import UniqueObject, getToolByName
from Products.CMFCore.CMFCorePermissions import ManagePortal
from Products.CMFCore.CMFCorePermissions import ModifyPortalContent

from Products.CMFCore.ActionInformation import ActionInformation
from Products.CMFCore.ActionProviderBase import ActionProviderBase
from Products.CMFCore.Expression import Expression

class ContentPanelsTool( UniqueObject, SimpleItem, PropertyManager, ActionProviderBase ):

#    __implements__ = (ActionProviderBase.__implements__)

    id = 'portal_contentpanels'
    meta_type = 'ContentPanels Tool'
    _actions = (ActionInformation(id='latest_updates_viewlet'
                                , title='Lastest Updates'
                                , action=Expression(
                text='string:here/folder_viewlet_macros/macros/latest_updates')
                                , condition=Expression(
                text='python: object.isPrincipiaFolderish')
                                , permissions=('View',)
                                , category='panel_viewlets'
                                , visible=1
                                 )
               ,
               ActionInformation(id='default_viewlet'
                                , title='Default Viewlet'
                                , action=Expression(
                text='string:here/contentpanels_default_viewlet')
                                , condition=Expression(
                text='python: 1')
                                , permissions=('View',)
                                , category='panel_viewlets'
                                , visible=1
                                 )
               )

    security = ClassSecurityInfo()

    manage_options = (ActionProviderBase.manage_options +
                #     ({ 'label' : 'Overview', 'action' : 'manage_overview' }
                #     , 
                #     ) + 
                     PropertyManager.manage_options +
                     SimpleItem.manage_options)

    def __init__(self):
        self._setProperty('Blank Box', 'here/contentpanels_NoBorderNoTitleSkin/macros/skinslot', 'string')
        self._setProperty('Title Only', 'here/contentpanels_NoBorderWithTitleSkin/macros/skinslot', 'string')
        self._setProperty('Plone Box', 'here/contentpanels_PloneSlotSkin/macros/skinslot', 'string')
        self._setProperty('Blue Box', 'here/contentpanels_BlueBoxSkin/macros/skinslot', 'string')
        self._setProperty('Yellow Box', 'here/contentpanels_YellowBoxSkin/macros/skinslot', 'string')
        self._setProperty('Red Box',  'here/contentpanels_RedBoxSkin/macros/skinslot', 'string')

    def valid_property_id(self, id):
        if not id or id[:1]=='_' or (id[:3]=='aq_') \
           or hasattr(aq_base(self), id) or escape(id) != id:
            return 0
        return 1

    security.declarePublic('getPanelSkins')
    def getPanelSkins(self):
        return filter(lambda i: (i[0] != 'title'), list(self.propertyItems()))

InitializeClass( ContentPanelsTool )
